﻿using System.Collections.Generic;

namespace Recogmission.ResharperPlugin.SampleFiles
{
    /// <summary>
    /// "int" must be unchanged!
    /// </summary>
    public enum Test: int
    {
        
    }
    
    public class MyClass<T>
    {
        /// <summary>
        /// Fields test.
        /// </summary>
        private short{caret} someField;
        
        private double someDoubleField;

        /// <summary>
        /// Property test.
        /// </summary>
        public float SomeProperty
        {
            get;
            set;
        }

        public MyClass()
        {
            // Array expression test.
            int[] testArray = new int[10];
            
            // Generic declaration test.
            Dictionary<int, string> test = new Dictionary<int, string>();
        }
        
        public T ConvertTo<T>()
        {
            // Cast expression test.
            return (T)(object)this;
        }

        public bool ConvertToBoolean()
        {
            // Method type argument test.
            return ConvertTo<bool>();
        }

        public void SomeSignature(string a, int b, long c, params ulong[] d)
        {
        
        }
    }

    public static class MyUtilityClass
    {
        /// <summary>
        /// Return value test.
        /// </summary>
        /// <returns></returns>
        public static MyClass<string> CreateMyString()
        {
            // Class type argument test.
            return new MyClass<string>();
        }

    }
}